$regfile = "m8def.dat"			'specify the used micro
$crystal = 8000000			'used crystal frequency
$baud = 2400				'use baud rate
$hwstack = 32				'default use 32 for the hardware stack
$swstack = 20				'default use 20 for the SW stack
$framesize = 40				'default use 40 for the frame space

Declare Sub Nextchannel() As Void	'Deklaration der Unterroutine fr das Weiterschalten der Kanle

'Ein-Ausgnge definieren
Ddrb = 255				'PORT B Ausgnge fr die LED Treiber
Ddrd = 0				'PORT D Eingnge
Portd = 255				'PullUps von Port D einschalten


Kmux Alias Pind.0			'Mux - Weiterschaltung per Taster
Dim Z As Byte				'Zhler fr Ausgang Port B

Dim X As Word , Y As Word		'Schwellen fr die Pegel der Signalspannungen


'ADC configurieren
Config Adc = Single , Prescaler = Auto , Reference = Avcc   'Freilaufender ADC, Referenzspannung Avcc
Start Adc				'ADC starten

Waitms 100				'100 ms warten
Z = 1					'PinB0 = 1, Kanal 1 aktiv


Do					'Abfrageschleife

Debounce Kmux , 0 , Nextchannel , Sub	'Abfrage des Tasters t1 entprellt, Verzweigung auf Routine 'Nextchannel


X = Getadc(4)				'ADC-Eingang 4 an Pin 27, linkes Stereosignal
Y = Getadc(5)				'ADC-Eingang 5 an Pin 28, rechtes Stereosignal

If X < 350 And Y > 360 Then		'Taste links gedrckt?


Waitms 10		
If X < 350 And Y > 360 Then		'Wirklich nur Taste links gedrckt?
Waitms 30
X = Getadc(4)				'Taste losgelassen?
If X > 360 Then
If Z = 1 Then				'Zwischen Kanal 1 und 4 toggeln
z = 8
Goto Mark
End If
If Z = 8 Then
Z = 1
Goto Mark
End If
If Z <> 1 And Z <> 8 Then Z = 1		'Auf Kanal 1, wenn nicht 1 oder 4 ausgewhlt war
Mark:
End If
End If
End If



If Y < 350 And X > 360 Then		'Taste rechts gedrckt?
Waitms 10
If Y < 350 And X > 360 Then		'Wirklich nur Taste rechts gedrckt?
Waitms 30
Y = Getadc(5)
If Y > 360 Then				'Taste losgelassen?
If Z = 2 Then				'Zwischen Kanal 2 und 5 toggeln
Z = 16
Goto Mark1
End If
If Z = 16 Then
Z = 2
Goto Mark1
End If
If Z <> 16 And Z <> 2 Then Z = 2		'Auf Kanal 2, wenn nicht 2 oder 5 ausgewhlt war
Mark1:
End If
End If
End If


If Y < 350 And X < 360 Then		'Beide Tasten gedrckt?
Waitms 10
If Y < 350 And X < 360 Then		'Wirklich beide Tasten gedrckt?
Waitms 30
Y = Getadc(5)
X = Getadc(4)
If Y > 360 And X > 360 Then		'Beide Tasten losgelassen?
If Z = 4 Then
Z = 32
Goto Mark2
End If
If Z = 32 Then
Z = 4
Goto Mark2
End If
If Z <> 32 And Z <> 4 Then Z = 4
Mark2:
End If
End If
End If

Portb = Z
Loop

Nextchannel:
Z = Z * 2				'Schieberegister PORTB
If Z = 64 Then Z = 1			'Rcksetzen, wenn Kanalnummer > 6
Return
